From 4b7d9cd4a018898d7714ce06f3faf2626c14582b Mon Sep 17 00:00:00 2001
From: Werner Koch <wk@gnupg.org>
Date: Wed, 5 Oct 2022 14:19:06 +0200
Subject: [PATCH] Detect a possible overflow directly in the TLV parser.

* src/ber-help.c (_ksba_ber_read_tl): Check for overflow of a commonly
used sum.
--

It is quite common to have checks like

    if (ti.nhdr + ti.length >= DIM(tmpbuf))
       return gpg_error (GPG_ERR_TOO_LARGE);

This patch detects possible integer overflows immmediately when
creating the TI object.

Reported-by: ZDI-CAN-18927, ZDI-CAN-18928, ZDI-CAN-18929
---
 src/ber-help.c | 6 ++++++
 1 file changed, 6 insertions(+)

diff --git a/src/ber-help.c b/src/ber-help.c
index 81c31ed..56efb6a 100644
--- a/src/ber-help.c
+++ b/src/ber-help.c
@@ -178,14 +178,20 @@ _ksba_ber_read_tl (ksba_reader_t reader, struct tag_info *ti)
             }
           ti->buf[ti->nhdr++] = c;
           len |= c & 0xff;
         }
       ti->length = len;
     }
 
+  if (ti->length > ti->nhdr && (ti->nhdr + ti->length) < ti->length)
+    {
+      ti->err_string = "header+length would overflow";
+      return gpg_error (GPG_ERR_EOVERFLOW);
+    }
+
   /* Without this kludge some example certs can't be parsed */
   if (ti->class == CLASS_UNIVERSAL && !ti->tag)
     ti->length = 0;
 
   return 0;
 }
 
-- 
2.35.1

